library wlxZZ_DT;

{  ZigZag        
               .

   Depth   - ,      
   ()  ()  Deviation ,  ,  
    ZigZag  ,   (  ) ,
     Deviation, ZigZag    Depth .
   Backstep       ().

    ,  ZigZag   ,    
      ,        
   .      ,  (   
     )  ZigZag    (  
    )   .

          .

 }

uses
  SysUtils,
  classes,
  graphics,
  windows,
  IndicatorInterfaceUnit,
  TechnicalFunctions in 'TechnicalFunctions.pas';

var

  //  
  Depth   :integer;
  //, Deviation, BackStep : integer;

  //  
  ZZ : TIndexBuffer;
  zzH: TIndexBuffer;
  zzL: TIndexBuffer;
  
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------

procedure Init; stdcall;

begin

//  

  IndicatorShortName('wlxZZ-DT');      //  ZigZug
  SetOutputWindow(ow_ChartWindow);


  //  
  AddSeparator('Common');

  RegOption('Depth', ot_Integer, Depth);
  SetOptionRange('Depth', 1, MaxInt);
  Depth := 12;
    
  //   

  zz  := CreateIndexBuffer;
  zzH := CreateIndexBuffer;
  zzL := CreateIndexBuffer;

  IndicatorBuffers(1);

  SetIndexBuffer(0, zz);
  SetIndexStyle (0, ds_Section, psSolid, 2, clYellow);
  SetEmptyValue(0.0);
                         
end;

 

//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------

procedure Done; stdcall;

begin
  // .  

end;



//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------

procedure Calculate(index: integer); stdcall;
var
  i, shift, pos,lasthighpos,lastlowpos,curhighpos, curlowpos: integer;
  curlow,curhigh,lasthigh,lastlow: real;
  cmin,cmax: real;

  //------------------------------------------------------------------
  function LowestPos(sh:integer; cnt:integer): integer;
  var lmin: real;
      j,clow:integer;
  begin
    lmin:=Low(sh);
    clow:=sh;
    for j:=sh to sh+cnt do begin
       if lmin>Low(j) then begin
         lmin:=Low(j);
         clow:=j;
       end;
    end;
    result:=clow;
  end;
  //------------------------------------------------------------------
  function HighestPos(sh:integer; cnt:integer): integer;
  var lmax: real;
      j,chigh:integer;
  begin
    lmax:=High(sh);
    chigh:=sh;
    for j:=sh to sh+cnt do begin
       if lmax<High(j) then begin
         lmax:=High(j);
         chigh:=j;
       end;
    end;
    result:=chigh;
  end;
  //------------------------------------------------------------------
  //------------------------------------------------------------------
begin

  if index<>0 then exit;

  lasthighpos:=Bars;
  lastlowpos :=Bars;
  lastlow :=Low(bars);
  lasthigh:=High(bars);

  for shift:=Bars-depth downto 0 do begin
    curlowpos:=LowestPos(shift,depth);
    curlow:=GetLowestValue(vt_Low,shift,depth);
    curHighpos:=HighestPos(shift,depth);
    curHigh:=GetHighestValue(vt_High,shift,depth);
    zz[shift]:=0.0;
    zzH[shift]:=0.0;
    zzL[shift]:=0.0;
    //------------------------------------------------------------------
    if (curlow>=lastlow)
     then lastlow:=curlow
     else begin
        if (lasthighpos>curlowpos) then begin
           zzL[curlowpos]:=curlow;
           cmin:=100000.0;
           pos:=lasthighpos;
           for i:=lasthighpos downto curlowpos do begin
              if (zzL[i]=0.0) then continue;
              if (zzL[i]< cmin) then begin
                  cmin:=zzL[i];
                  pos:=i;
              end;
              zz[i]:=0.0;
           end;
           zz[pos]:=cmin;
        end;
        lastlowpos:=curlowpos;
        lastlow:=curlow;
     end;
     //------------------------------------------------------------------
    if (curhigh<=lasthigh)
     then lasthigh:=curhigh
     else begin
        if (lastlowpos>curhighpos) then begin
           zzH[curhighpos]:=curhigh;
           cmax:=-100000.0;
           pos:=lastlowpos;
           for i:=lastlowpos downto curhighpos do begin
              if (zzH[i]=0.0) then continue;
              if (zzH[i]> cmax) then begin
                  cmax:=zzH[i];
                  pos:=i;
              end;
              zz[i]:=0.0;
           end;
           zz[pos]:=cmax;
        end;
        lasthighpos:=curhighpos;
        lasthigh:=curhigh;
     end;
     //Print(format('zz: %.4f, %d', [zz[shift],shift]));
  end;

end;



exports

//       

Init, Done, Calculate;



end.


